import greenfoot.*;

/**
 * MyKara is a subclass of Kara. Therefore, it inherits all methods of Kara:
 * <p>
 * 
 * <i>MyKara ist eine Unterklasse von Kara. Sie erbt damit alle Methoden der
 * Klasse Kara:</i>
 * <p>
 * 
 * Actions: move(), turnLeft(), turnRight(), putLeaf(), removeLeaf() <b>
 * Sensors: onLeaf(), treeFront(), treeLeft(), treeRight(), mushroomFront()
 */
public class MyKara extends Kara {
    int antiUmdrehen = 1;
    int SpeedKara;
    boolean antiDoppelDrehen=true;
    int score = 0;
    boolean end=false;
    
    int speicherX;
    int speicherY;
    Krper[] krper = new Krper[102];
    boolean zustzlicheKara;
    KaraWorld myWorld;
    public void act() {
        steuern();
        eatLeaf();
    }
    
    public void steuern(){
        drehsteuerung("right", 0, 3, 1);
        drehsteuerung("down", 90, 4, 2);
        drehsteuerung("left", 180, 1, 3);
        drehsteuerung("up", 270, 2, 4);
        SpeedKara++;
        if(SpeedKara%170==0){
            
            speicherX = getX();
            speicherY = getY();
            for(int i = score + 1; i > 0; i--) {
                krper[i] = krper[i - 1];
            }
            if(zustzlicheKara == false) {
                getWorld().removeObject(krper[score + 1]);
            }
            zustzlicheKara = false;
            move();
            if(onKrper()) {
                Greenfoot.setWorld(new GameOverWorld());
            }
            antiDoppelDrehen=true;
            krper[0] = new Krper();
            getWorld().addObject(krper[0], speicherX, speicherY);
            
        }
    }
    public void eatLeaf(){
        if(onLeaf()){
            removeLeaf();
            score++;
            myWorld.score++;
            zustzlicheKara = true;
            
            int XnewLeaf = Greenfoot.getRandomNumber(10);
            int YnewLeaf = Greenfoot.getRandomNumber(10);
            getWorld().addObject(new Leaf(), XnewLeaf, YnewLeaf);
        }
        
    }
    
    public void drehsteuerung(String richtung, int grad, int antiDrehwert, int antiSkrskr){
        if(Greenfoot.isKeyDown(richtung) && antiUmdrehen!=antiDrehwert && antiDoppelDrehen==true){
                setRotation(grad);
                antiUmdrehen=antiSkrskr;
                antiDoppelDrehen=false;
        }
        
    }
}

